]> git.ipfire.org Git - thirdparty/git.git/blame - git-filter-branch.sh
filter-branch: stop special-casing $filter_subdir argument
[thirdparty/git.git] / git-filter-branch.sh
CommitLineData
6f6826c5
JS
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
c401b33c
JS
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
6f6826c5 10
16ed34ad
JS
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
b5669a05
SP
14warn () {
15 echo "$*" >&2
16}
17
6f6826c5
JS
18map()
19{
3520e1e8 20 # if it was not rewritten, take the original
c57a3494
JS
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
6f6826c5
JS
27}
28
f95eef15
JS
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
d3240d93
PH
43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44# it will skip commits that leave the tree untouched, commit the other.
45git_commit_non_empty_tree()
46{
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
51 fi
52}
8c1ce0f4
JS
53# override die(): this version puts in an extra line break, so that
54# the progress is still visible
55
56die()
57{
58 echo >&2
59 echo "$*" >&2
60 exit 1
61}
16ed34ad
JS
62EOF
63)
64
65eval "$functions"
8c1ce0f4 66
6f6826c5
JS
67# When piped a commit, output a script to set the ident of either
68# "author" or "committer
69
70set_ident () {
40a7ce64
JK
71 lid="$(echo "$1" | tr "[A-Z]" "[a-z]")"
72 uid="$(echo "$1" | tr "[a-z]" "[A-Z]")"
6f6826c5
JS
73 pick_id_script='
74 /^'$lid' /{
75 s/'\''/'\''\\'\'\''/g
76 h
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
78 s/'\''/'\''\'\'\''/g
3addc94a 79 s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
6f6826c5
JS
80
81 g
82 s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
83 s/'\''/'\''\'\'\''/g
3addc94a 84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
6f6826c5
JS
85
86 g
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
88 s/'\''/'\''\'\'\''/g
3addc94a 89 s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
6f6826c5
JS
90
91 q
92 }
93 '
94
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
3addc94a 97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
6f6826c5
JS
98}
99
83e355a6
MM
100USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
7e0f1704 106
8f321a39 107OPTIONS_SPEC=
7e0f1704
JS
108. git-sh-setup
109
a4661b01 110if [ "$(is_bare_repository)" = false ]; then
26be15f0 111 git diff-files --ignore-submodules --quiet &&
38762c47 112 git diff-index --cached --quiet HEAD -- ||
46eb449c 113 die "Cannot rewrite branch(es) with a dirty working directory."
a4661b01 114fi
46eb449c 115
6f6826c5 116tempdir=.git-rewrite
6f6826c5
JS
117filter_env=
118filter_tree=
119filter_index=
120filter_parent=
121filter_msg=cat
d3240d93 122filter_commit=
6f6826c5 123filter_tag_name=
685ef546 124filter_subdir=
dfd05e38
JS
125orig_namespace=refs/original/
126force=
d3240d93 127prune_empty=
822f7c73 128while :
6f6826c5
JS
129do
130 case "$1" in
131 --)
132 shift
133 break
134 ;;
dfd05e38
JS
135 --force|-f)
136 shift
137 force=t
138 continue
139 ;;
d3240d93
PH
140 --prune-empty)
141 shift
142 prune_empty=t
143 continue
144 ;;
6f6826c5
JS
145 -*)
146 ;;
147 *)
148 break;
149 esac
150
151 # all switches take one argument
152 ARG="$1"
153 case "$#" in 1) usage ;; esac
154 shift
155 OPTARG="$1"
156 shift
157
158 case "$ARG" in
159 -d)
160 tempdir="$OPTARG"
161 ;;
6f6826c5
JS
162 --env-filter)
163 filter_env="$OPTARG"
164 ;;
165 --tree-filter)
166 filter_tree="$OPTARG"
167 ;;
168 --index-filter)
169 filter_index="$OPTARG"
170 ;;
171 --parent-filter)
172 filter_parent="$OPTARG"
173 ;;
174 --msg-filter)
175 filter_msg="$OPTARG"
176 ;;
177 --commit-filter)
16ed34ad 178 filter_commit="$functions; $OPTARG"
6f6826c5
JS
179 ;;
180 --tag-name-filter)
181 filter_tag_name="$OPTARG"
182 ;;
685ef546
JS
183 --subdirectory-filter)
184 filter_subdir="$OPTARG"
185 ;;
dfd05e38 186 --original)
55ced83d 187 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
dfd05e38 188 ;;
6f6826c5
JS
189 *)
190 usage
191 ;;
192 esac
193done
194
d3240d93
PH
195case "$prune_empty,$filter_commit" in
196,)
197 filter_commit='git commit-tree "$@"';;
198t,)
199 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
200,*)
201 ;;
202*)
203 die "Cannot set --prune-empty and --filter-commit at the same time"
204esac
205
dfd05e38
JS
206case "$force" in
207t)
208 rm -rf "$tempdir"
209;;
210'')
211 test -d "$tempdir" &&
212 die "$tempdir already exists, please remove it"
213esac
af580e9c 214mkdir -p "$tempdir/t" &&
dfd05e38 215tempdir="$(cd "$tempdir"; pwd)" &&
af580e9c
JS
216cd "$tempdir/t" &&
217workdir="$(pwd)" ||
218die ""
6f6826c5 219
def16e71
BC
220# Remove tempdir on exit
221trap 'cd ../..; rm -rf "$tempdir"' 0
222
88e38808
LN
223ORIG_GIT_DIR="$GIT_DIR"
224ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
225ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
226GIT_WORK_TREE=.
227export GIT_DIR GIT_WORK_TREE
228
dfd05e38 229# Make sure refs/original is empty
0ea29cce 230git for-each-ref > "$tempdir"/backup-refs || exit
dfd05e38
JS
231while read sha1 type name
232do
233 case "$force,$name" in
234 ,$orig_namespace*)
734cd572
JT
235 die "Cannot create a new backup.
236A previous backup already exists in $orig_namespace
237Force overwriting the backup with -f"
dfd05e38
JS
238 ;;
239 t,$orig_namespace*)
240 git update-ref -d "$name" $sha1
241 ;;
242 esac
243done < "$tempdir"/backup-refs
244
418fa3a5 245# The refs should be updated if their heads were rewritten
0ea29cce
EK
246git rev-parse --no-flags --revs-only --symbolic-full-name \
247 --default HEAD "$@" > "$tempdir"/raw-heads || exit
248sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
dfd05e38
JS
249
250test -s "$tempdir"/heads ||
251 die "Which ref do you want to rewrite?"
252
3addc94a
JS
253GIT_INDEX_FILE="$(pwd)/../index"
254export GIT_INDEX_FILE
af580e9c 255git read-tree || die "Could not seed the index"
6f6826c5 256
af580e9c
JS
257# map old->new commit ids for rewriting parents
258mkdir ../map || die "Could not create map/ directory"
6f6826c5 259
2c1d2d81
TR
260# we need "--" only if there are no path arguments in $@
261nonrevs=$(git rev-parse --no-revs "$@") || exit
262test -z "$nonrevs" && dashdash=-- || dashdash=
263rev_args=$(git rev-parse --revs-only "$@")
264
685ef546
JS
265case "$filter_subdir" in
266"")
2c1d2d81 267 eval set -- "$(git rev-parse --sq --no-revs "$@")"
685ef546
JS
268 ;;
269*)
2c1d2d81
TR
270 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
271 "$filter_subdir")"
272 ;;
273esac
274
275git rev-list --reverse --topo-order --default HEAD \
276 --parents --simplify-merges $rev_args "$@" > ../revs ||
277 die "Could not get the commits"
9d6f220c 278commits=$(wc -l <../revs | tr -d " ")
6f6826c5
JS
279
280test $commits -eq 0 && die "Found nothing to rewrite"
281
dfd05e38
JS
282# Rewrite the commits
283
d5b0c97d 284git_filter_branch__commit_count=0
813b4734 285while read commit parents; do
d5b0c97d
EN
286 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
287 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
6f6826c5 288
685ef546
JS
289 case "$filter_subdir" in
290 "")
5be60078 291 git read-tree -i -m $commit
685ef546
JS
292 ;;
293 *)
5b044ac3
JH
294 # The commit may not have the subdirectory at all
295 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
d69da76d 296 if ! git rev-parse -q --verify $commit:"$filter_subdir"
5b044ac3
JH
297 then
298 rm -f "$GIT_INDEX_FILE"
299 else
300 echo >&2 "$err"
301 false
302 fi
303 }
af580e9c 304 esac || die "Could not initialize the index"
6f6826c5 305
3addc94a
JS
306 GIT_COMMIT=$commit
307 export GIT_COMMIT
af580e9c
JS
308 git cat-file commit "$commit" >../commit ||
309 die "Cannot read commit $commit"
6f6826c5 310
8c1ce0f4
JS
311 eval "$(set_ident AUTHOR <../commit)" ||
312 die "setting author failed for commit $commit"
313 eval "$(set_ident COMMITTER <../commit)" ||
314 die "setting committer failed for commit $commit"
315 eval "$filter_env" < /dev/null ||
316 die "env filter failed: $filter_env"
6f6826c5
JS
317
318 if [ "$filter_tree" ]; then
af580e9c
JS
319 git checkout-index -f -u -a ||
320 die "Could not checkout the index"
6f6826c5
JS
321 # files that $commit removed are now still in the working tree;
322 # remove them, else they would be added again
6a589fda 323 git clean -d -q -f -x
8c1ce0f4
JS
324 eval "$filter_tree" < /dev/null ||
325 die "tree filter failed: $filter_tree"
326
1fe32cb9 327 (
0ea29cce 328 git diff-index -r --name-only $commit &&
1fe32cb9 329 git ls-files --others
0ea29cce
EK
330 ) > "$tempdir"/tree-state || exit
331 git update-index --add --replace --remove --stdin \
332 < "$tempdir"/tree-state || exit
6f6826c5
JS
333 fi
334
8c1ce0f4
JS
335 eval "$filter_index" < /dev/null ||
336 die "index filter failed: $filter_index"
6f6826c5
JS
337
338 parentstr=
813b4734 339 for parent in $parents; do
3520e1e8
JS
340 for reparent in $(map "$parent"); do
341 parentstr="$parentstr -p $reparent"
342 done
6f6826c5
JS
343 done
344 if [ "$filter_parent" ]; then
8c1ce0f4
JS
345 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
346 die "parent filter failed: $filter_parent"
6f6826c5
JS
347 fi
348
349 sed -e '1,/^$/d' <../commit | \
8c1ce0f4
JS
350 eval "$filter_msg" > ../message ||
351 die "msg filter failed: $filter_msg"
4bf9f27d 352 @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
0ea29cce
EK
353 $(git write-tree) $parentstr < ../message > ../map/$commit ||
354 die "could not write rewritten commit"
6f6826c5
JS
355done <../revs
356
dfd05e38
JS
357# In case of a subdirectory filter, it is possible that a specified head
358# is not in the set of rewritten commits, because it was pruned by the
a0e46390
TR
359# revision walker. Fix it by mapping these heads to the unique nearest
360# ancestor that survived the pruning.
dfd05e38 361
a0e46390
TR
362if test "$filter_subdir"
363then
364 while read ref
dfd05e38 365 do
a0e46390
TR
366 sha1=$(git rev-parse "$ref"^0)
367 test -f "$workdir"/../map/$sha1 && continue
2c1d2d81 368 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
a0e46390
TR
369 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
370 done < "$tempdir"/heads
371fi
dfd05e38
JS
372
373# Finally update the refs
374
375_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
376_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
dfd05e38
JS
377echo
378while read ref
379do
380 # avoid rewriting a ref twice
381 test -f "$orig_namespace$ref" && continue
382
383 sha1=$(git rev-parse "$ref"^0)
384 rewritten=$(map $sha1)
385
386 test $sha1 = "$rewritten" &&
387 warn "WARNING: Ref '$ref' is unchanged" &&
388 continue
389
390 case "$rewritten" in
391 '')
392 echo "Ref '$ref' was deleted"
393 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
394 die "Could not delete $ref"
98409060 395 ;;
dfd05e38
JS
396 $_x40)
397 echo "Ref '$ref' was rewritten"
261044e8
TR
398 if ! git update-ref -m "filter-branch: rewrite" \
399 "$ref" $rewritten $sha1 2>/dev/null; then
400 if test $(git cat-file -t "$ref") = tag; then
401 if test -z "$filter_tag_name"; then
402 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
403 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
404 fi
405 else
406 die "Could not rewrite $ref"
407 fi
408 fi
98409060 409 ;;
dfd05e38
JS
410 *)
411 # NEEDSWORK: possibly add -Werror, making this an error
412 warn "WARNING: '$ref' was rewritten into multiple commits:"
413 warn "$rewritten"
414 warn "WARNING: Ref '$ref' points to the first one now."
415 rewritten=$(echo "$rewritten" | head -n 1)
416 git update-ref -m "filter-branch: rewrite to first" \
417 "$ref" $rewritten $sha1 ||
418 die "Could not rewrite $ref"
419 ;;
420 esac
0ea29cce
EK
421 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
422 exit
dfd05e38
JS
423done < "$tempdir"/heads
424
425# TODO: This should possibly go, with the semantics that all positive given
426# refs are updated, and their original heads stored in refs/original/
427# Filter tags
6f6826c5
JS
428
429if [ "$filter_tag_name" ]; then
5be60078 430 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
6f6826c5
JS
431 while read sha1 type ref; do
432 ref="${ref#refs/tags/}"
433 # XXX: Rewrite tagged trees as well?
434 if [ "$type" != "commit" -a "$type" != "tag" ]; then
435 continue;
436 fi
437
438 if [ "$type" = "tag" ]; then
439 # Dereference to a commit
440 sha1t="$sha1"
7bd93c1c 441 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
6f6826c5
JS
442 fi
443
444 [ -f "../map/$sha1" ] || continue
445 new_sha1="$(cat "../map/$sha1")"
3addc94a
JS
446 GIT_COMMIT="$sha1"
447 export GIT_COMMIT
8c1ce0f4
JS
448 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
449 die "tag name filter failed: $filter_tag_name"
6f6826c5
JS
450
451 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
452
453 if [ "$type" = "tag" ]; then
a9da1663
JS
454 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
455 "$new_sha1" "$new_ref"
456 git cat-file tag "$ref" |
1bf6551e
BC
457 sed -n \
458 -e "1,/^$/{
a9da1663
JS
459 /^object /d
460 /^type /d
461 /^tag /d
1bf6551e
BC
462 }" \
463 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
a9da1663 464 -e 'p' ) |
1bf6551e
BC
465 git mktag) ||
466 die "Could not create new tag object for $ref"
467 if git cat-file tag "$ref" | \
468 grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
469 then
470 warn "gpg signature stripped from tag object $sha1t"
471 fi
6f6826c5
JS
472 fi
473
af580e9c
JS
474 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
475 die "Could not write tag $new_ref"
6f6826c5
JS
476 done
477fi
478
479cd ../..
480rm -rf "$tempdir"
6f6826c5 481
def16e71
BC
482trap - 0
483
9273b562
EK
484unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
485test -z "$ORIG_GIT_DIR" || {
486 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
487}
488test -z "$ORIG_GIT_WORK_TREE" || {
489 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
490 export GIT_WORK_TREE
491}
492test -z "$ORIG_GIT_INDEX_FILE" || {
493 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
494 export GIT_INDEX_FILE
495}
496
a4661b01 497if [ "$(is_bare_repository)" = false ]; then
0ea29cce 498 git read-tree -u -m HEAD || exit
a4661b01 499fi
46eb449c 500
0ea29cce 501exit 0